datablock ProjectileData(BinoculerProjectileA)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	directDamage        = 0;
	directDamageType    = $DamageType::Generic;
	radiusDamageType    = $DamageType::Generic;
	
	particleEmitter = LaserPointEmitterA;
	
	soundProfile = radioWaveTravelSound;
	
	brickExplosionRadius = 0;
	brickExplosionImpact = 0;             //destroy a brick if we hit it directly?
	brickExplosionForce  = 0;             
	brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)
	
	collideWithPlayers = true;
	
	muzzleVelocity      = 1;
	velInheritFactor    = 1.0;
	
	armingDelay         = 4000;
	lifetime            = 4000;
	fadeDelay           = 4000;
	bounceElasticity    = 0;
	bounceFriction      = 0.00;
	isBallistic         = true;
	gravityMod          = 0.0;
	
	hasLight    = false;
	lightRadius = 1;
	lightColor = "0.01 0 0";
	
	uiName = "Laser Pointer FX";
};

//////////
// item //
//////////
datablock ItemData(BinoculerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	// Basic Item Properties
	shapeFile = "base/data/shapes/printGun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	//gui stuff
	uiName = "Binoculars";
	iconName = "base/client/ui/itemIcons/printer";
	doColorShift = true;
	colorShiftColor = "0.2 0.2 0.2 1.000";
	
	// Dynamic properties defined by the scripts
	image = BinoculerImage;
	canDrop = true;

	gc_zoom = 14;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(BinoculerImage)
{
	// Basic Item properties
	shapeFile = "base/data/shapes/printGun.dts";
	emap = true;
	
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0;
	rotation = "1 0 0 0";
	correctMuzzleVector = true;
	className = "WeaponImage";
	
	// Projectile && Ammo.
	item = BinoculerItem;
	ammo = " ";
	projectile = BinoculProjectileA;
	projectileType = Projectile;
	
	//melee particles shoot from eye node for consistancy
	melee = true;
	//raise your arm up or not
	armReady = true;
	
	doRetraction = false;
	
	raycastWeaponRange = 3000;
	raycastWeaponTargets =
		$TypeMasks::PlayerObjectType |    //AI/Players
			$TypeMasks::StaticObjectType |    //Static Shapes
			$TypeMasks::TerrainObjectType |    //Terrain
			$TypeMasks::VehicleObjectType |    //Terrain
			$TypeMasks::FXBrickObjectType;    //Bricks
	raycastExplosionProjectile = BinoculProjectileA;
	raycastExplosionBrickSound = "";
	raycastExplosionPlayerSound = "";
	raycastDirectDamage = 0;
	raycastDirectDamageType = $DamageType::Generic;
	
	doColorShift = true;
	colorShiftColor = BinoculerItem.colorShiftColor;//"0.400 0.196 0 1.000";
	
	//casing = " ";
	
	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.
	
	// Initial start up state
	stateName[0]                     = "Activate";
	stateTransitionOnTriggerDown[0]  = "Fire";
	stateAllowImageChange[0]	   = true;
	stateSound[0]			   = weaponSwitchSound;
	stateTransitionOnTimeout[0]	   = "Ready";
	stateTimeoutValue[0]		   = 0.3;
	
	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]	   = true;
	
	//stateName[2]			= "PreFire";
	//stateSound[2]			= "";
	//stateTimeoutValue[2]		= 0.01;
	//stateTransitionOnTimeout[2]	= "Fire";
	
	stateName[2]                     = "Fire";
	stateTransitionOnTriggerUp[2]	   = "StopFire";
	stateTransitionOnTimeout[2]	   = "Fire";
	stateTimeoutValue[2]		   = 0.01;
	stateWaitForTimeout[2]		   = true;
	stateFire[2]			   = true;
	stateAllowImageChange[2]	   = true;
	stateSound[2]			   = radioWaveTravelSound;
	stateScript[2]			   = "onFire";
	stateEmitter[2]			   = LaserPointEmitterB;
	stateEmitterTime[2]		   = 0.07;
	stateSequence[2]			   = "fire";
	
	stateName[3] 			   = "StopFire";
	stateTransitionOnTimeout[3]	   = "Ready";
	stateWaitForTimeout[3]		   = true;
	stateAllowImageChange[3]	   = true;
	stateSequence[3]			   = "stopfire";
};

function BinoculerImage::onFire(%this,%obj,%slot)
{
	if(isObject(%obj.client))
		%obj.client.bottomPrint("\c0Distance\c3: ERROR",1);
	
	Parent::onFire(%this,%obj,%slot);
}

function BinoculerImage::onHitObject(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
	if(!isObject(%col))
		return;
	
	%colType = %col.getType(); //%col changes to CorpseObjectType if you kill a player 
	
	if(!isObject(CritProjectile))
		%crit = 0;
	
	if(%this.raycastDirectDamage > 0 && %colType & ($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType))
	{
		if(isObject(%col.spawnBrick) && %col.spawnBrick.getGroup().client == %obj.client)
			%dmg = 1;
		if(miniGameCanDamage(%obj,%col) == 1 || %dmg)
			%this.onRaycastDamage(%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
	}
	
	if(isObject(%obj.client))
		%obj.client.bottomPrint("\c0Distance\c3: " @ mFloatLength(vectorDist(%obj.getMuzzlePoint(%slot),%pos),1),1);
	
	if(isObject(%this.raycastExplosionSound))
		serverplay3d(%this.raycastExplosionSound,%pos);
	
	if(isObject(%this.raycastExplosionCritSound) && %crit)
		serverplay3d(%this.raycastExplosionCritSound,%pos);
	
	%colPlayer = (%colType & $TypeMasks::PlayerObjectType);
	
	if(%colPlayer && isObject(%this.raycastExplosionPlayerSound))
		serverplay3d(%this.raycastExplosionPlayerSound,%pos);
	else if(!%colPlayer && isObject(%this.raycastExplosionBrickSound))
		serverplay3d(%this.raycastExplosionBrickSound,%pos);
}

datablock ShapeBaseImageData(BinoculerImageZoomed : BinoculerImage)
{

	
	// Initial start up state
	stateName[0]                     = "Activate";
	stateTransitionOnTriggerDown[0]  = "Fire";
	stateAllowImageChange[0]	   = true;
	stateSound[0]			   = weaponSwitchSound;
	stateTransitionOnTimeout[0]	   = "Ready";
	stateTimeoutValue[0]		   = 0.3;
	
	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]	   = true;
	
	//stateName[2]			= "PreFire";
	//stateSound[2]			= "";
	//stateTimeoutValue[2]		= 0.01;
	//stateTransitionOnTimeout[2]	= "Fire";
	
	stateName[2]                     = "Fire";
	stateTransitionOnTriggerUp[2]	   = "StopFire";
	stateTransitionOnTimeout[2]	   = "Fire";
	stateTimeoutValue[2]		   = 0.01;
	stateWaitForTimeout[2]		   = true;
	stateFire[2]			   = true;
	stateAllowImageChange[2]	   = true;
	stateSound[2]			   = radioWaveTravelSound;
	stateScript[2]			   = "onFire";
	stateEmitter[2]			   = LaserPointEmitterB;
	stateEmitterTime[2]		   = 0.07;
	stateSequence[2]			   = "fire";
	
	stateName[3] 			   = "StopFire";
	stateTransitionOnTimeout[3]	   = "Ready";
	stateWaitForTimeout[3]		   = true;
	stateAllowImageChange[3]	   = true;
	stateSequence[3]			   = "stopfire";
};

function BinoculerImageZoomed::onFire(%this,%obj,%slot)
{
	if(isObject(%obj.client))
		%obj.client.bottomPrint("\c0Distance\c3: ERROR",1);
	
	Parent::onFire(%this,%obj,%slot);
}

function BinoculerImageZoomed::onHitObject(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
	if(!isObject(%col))
		return;
	
	%colType = %col.getType(); //%col changes to CorpseObjectType if you kill a player 
	
	if(!isObject(CritProjectile))
		%crit = 0;
	
	if(%this.raycastDirectDamage > 0 && %colType & ($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType))
	{
		if(isObject(%col.spawnBrick) && %col.spawnBrick.getGroup().client == %obj.client)
			%dmg = 1;
		if(miniGameCanDamage(%obj,%col) == 1 || %dmg)
			%this.onRaycastDamage(%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
	}
	
	if(isObject(%obj.client))
		%obj.client.bottomPrint("\c0Distance\c3: " @ mFloatLength(vectorDist(%obj.getMuzzlePoint(%slot),%pos),1),1);
	
	if(isObject(%this.raycastExplosionSound))
		serverplay3d(%this.raycastExplosionSound,%pos);
	
	if(isObject(%this.raycastExplosionCritSound) && %crit)
		serverplay3d(%this.raycastExplosionCritSound,%pos);
	
	%colPlayer = (%colType & $TypeMasks::PlayerObjectType);
	
	if(%colPlayer && isObject(%this.raycastExplosionPlayerSound))
		serverplay3d(%this.raycastExplosionPlayerSound,%pos);
	else if(!%colPlayer && isObject(%this.raycastExplosionBrickSound))
		serverplay3d(%this.raycastExplosionBrickSound,%pos);
}